#

"""AXMLDocuments

"""

__version__='$Revision: 1.7 $'[11:-2]

from OFS.SimpleItem import SimpleItem, Item_w__name__
from OFS.PropertyManager import PropertyManager
from OFS.Cache import Cacheable
from OFS.History import Historical
from Products.ZCatalog.CatalogAwareness import CatalogAware
import Acquisition
from DateTime.DateTime import DateTime

from AccessControl import ClassSecurityInfo, getSecurityManager
from Globals import HTML, HTMLFile, DTMLFile, MessageDialog, InitializeClass

from urllib import quote
import re, string, traceback
from IAXMLDocument import IAXMLDocument

import os, tempfile, cgi




class AXMLDocument(CatalogAware, SimpleItem, Acquisition.Implicit, 
  PropertyManager, Historical, Cacheable, Item_w__name__):

  """AXML Documents"""


  meta_type = 'AXMLDocument'
  icon = 'p_/dtmldoc'

  pdf_src = body = raw_text = ''
  texte = ''

  index_html = None # Prevent accidental acquisition (XXX ???)

  manage_options = (
    (
      {'label':'Edit', 'action':'manage_main'},
      {'label':'View', 'action':''},
    )
    + PropertyManager.manage_options
    + Cacheable.manage_options
    + Historical.manage_options
  )

  security = ClassSecurityInfo()

  _metadata = ['title', 'author', 'publisher', 'source',
    'publication_date', 'description', 'keywords', 'summary']
  title = author = publisher = source = description = keywords = summary = ''
  _properties = (
    {'id':'title', 'type': 'string', 'mode': 'w'},
    {'id':'source', 'type': 'string', 'mode': 'w'},
  )

  __ac_permissions__=(
    ('Change AXML Documents',
     ('manage_editForm', 'manage', 'manage_main',
      'manage_edit', 'manage_upload', 'PUT',
      'manage_historyCopy',
      'manage_beforeHistoryCopy', 'manage_afterHistoryCopy',
      )
     ),
    )


  

  #
  # Constructor
  #
  def __init__(self, id='', title='', file='', __name__=''):
    if __name__ and not id:
      self._setId(__name__)
    else:
      self._setId(id)
    self.pdf_src = file
    self.title = id[:-4]

   

    import xml.dom.minidom
	
    self.liste = ['NAME','ADDRESS','PHONENUM','EMAIL']
    dom = ''
    print " %s" % self.pdf_src
	
    if self.pdf_src == '':
       pass
    else:
       dom = xml.dom.minidom.parseString(self.pdf_src)
	   
       for i in self.liste:
         valeur = self.marqueur(dom, i)
         setattr(self,i,valeur)
    
    self.reindex_object()
	  
  def marqueur(self, elm1, tag):
    rc = ""
    elm2 = elm1.getElementsByTagName(tag)
    for node in elm2:
      child_node = node.childNodes
      for  node2 in child_node:
        rc = rc + ' ' + node2.data
    return rc


  def updateState(self):

    import xml.dom.minidom
    liste = []
    dom = ''
    print " %s" % self.pdf_src
	
    if self.pdf_src == '':
       pass
    else:
       dom = xml.dom.minidom.parseString(self.pdf_src)

       
       for i in self.liste:
         valeur = self.marqueur(dom, i)
         setattr(self,i,valeur)

    self.ZCacheable_invalidate()
    self.reindex_object()


  manage_editForm = HTMLFile('dtml/editForm', globals())
  manage = manage_main = manage_editForm

  def manage_edit(self, data, title='', SUBMIT='Change', dtpref_cols='50',
          dtpref_rows='20', REQUEST=None):
    """
    Replaces a Documents contents with Data.

    """

    if title:
      self.title = title
    if type(data) is not type(''): 
      data = data.read()
    self.pdf_src = data
    self.updateState()

    if REQUEST:
      message="Content changed."
      return self.manage_main(self,REQUEST,manage_tabs_message=message)


  def manage_upload(self, file='', REQUEST=None):
    """Replace the contents of the document with the text in file."""

    if type(file) is not type(''): 
      file=file.read()
    self.pdf_src = file
    self.updateState()
    if REQUEST:
      message="Content uploaded."
      return self.manage_main(self,REQUEST,manage_tabs_message=message)

  def PUT(self, REQUEST, RESPONSE):
    "Handle HTTP/FTP PUT requests."

    self.dav__init(REQUEST, RESPONSE)
    self.pdf_src = REQUEST.get('BODY', '')
    self.updateState()
    RESPONSE.setStatus(204)
    return RESPONSE

  def manage_FTPget(self):
    "Get PDF source for FTP download"

    return self.pdf_src


  def document_src(self, REQUEST=None, RESPONSE=None):
    """Return unprocessed document source."""

    if RESPONSE is not None:
      RESPONSE.setHeader('Content-Type', 'text/xml')
    return self.pdf_src
	
  def xslt(self, client=None, REQUEST={}, RESPONSE=None, **kw):
    data = self.pdf_src
    data2 = self.stylesheet(self, REQUEST)
    
    self.tmpdir = tempfile.mktemp()
    os.mkdir('%s' % self.tmpdir)
    
    fd = open("%s/%s.xml" % (self.tmpdir, self.id[:-4]), "w")
    fd.write(data)
    fd.close()

    fd = open("%s/%s.xsl" % (self.tmpdir, self.id[:-4]), "w")
    fd.write(data2)
    fd.close()

    print self.id

    cmd = "cd '%s' &&  xsltproc --novalid -o '%s.html' '%s.xsl' '%s.xml'" \
      % (self.tmpdir, self.id[:-4], self.id[:-4], self.id[:-4])
	  
    os.system(cmd)
	
    self.xsltflux = open("%s/%s.html" % (self.tmpdir, self.id[:-4])).read()
	
    for fn in os.listdir("%s" % self.tmpdir):
      os.remove("%s/%s" % (self.tmpdir, fn))
    os.rmdir("%s" % self.tmpdir)
	
    return self.xsltflux
 


  def __call__(self, client=None, REQUEST={}, RESPONSE=None, **kw):
    "View document"
    security = getSecurityManager()
    security.addContext(self)
    try:
      if security.checkPermission('View', self.standard_html_header):
        res = self.standard_html_header(self, REQUEST)
#        res = res + self.pdf_src
        res = res + self.xslt()
      else:
        res = self.self_pdf
      if security.checkPermission('View', self.standard_html_footer):
        res = res + self.standard_html_footer(self, REQUEST)
    finally:
      security.removeContext(self)
    return res


InitializeClass(AXMLDocument)

addAXMLDocumentForm = HTMLFile('dtml/addForm', globals(), 
  Kind='AXMLDocument', kind='AXMLDocument')

def cookId(id, file):
  if not id and hasattr(file, 'filename'):
    filename = file.filename
    #title = title or filename
    id = filename[max(
      string.rfind(filename, '/'),
      string.rfind(filename, '\\'),
      string.rfind(filename, ':'),)+1:]
  return id

def addAXMLDocument(self, id, title='', file='', REQUEST=None, submit=None):
  """Add a AXMLDocument object with the contents of file."""

  id = str(id)
  id = cookId(id, file)
  if type(file) is not type(''): 
    file = file.read()

  ob = AXMLDocument(id=id, title=title, file=file)
  id = self._setObject(id, ob)
  if REQUEST is not None:
    try: u = self.DestinationURL()
    except: u = REQUEST['URL1']
    if submit == " Add and Edit ": u = "%s/%s" % (u, quote(id))
    REQUEST.RESPONSE.redirect(u + '/manage_main')
  return ''

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
# 
# vim:et:ts=2:ai
